/* $Header: /home/yav/fkiss/RCS/kisseve.c,v 1.14 1995/12/03 05:07:35 yav Exp $
 * KISS event extension
 * written by yav (UHD98984@pcvan.or.jp)
 *
 * CAUTION!
 * Experiment of event extension, NOT STANDARD!
 *
 *
 *;@EventHandler		; event extension identifier
 *;@never()			; never happen, ignore
 *;@initialize()		; startup event (before reading datas)
 *;@				;  Caution! at this event
 *;@				;  nop, debug, shell, unmap actions available.
 *;@				;  Don't use other actions!
 *;@	nop();			; No operation
 *;@	debug("here!\n");	; print string to stderr for debug
 *;@				;  arg1 string to print
 *;@	shell("echo Hello `whoami`");	; shell
 *;@				;  arg1 string passed to shell
 *;@				;  Caution! No compatibility (OS depend),
 *;@				;  and this function makes SECURITY HOLE.
 *;@				;  So, by default this function is disabled.
 *;@				;  ONLY -eventshell option is specified,
 *;@				;  this function is enabled.
 *;@	unmap("facered.cel");	; unmap cell
 *;@begin()			; begin event (at window is mapped)
 *;@	timer(1, 3000);		; setup timer
 *;@				;  (same as ramdomtimer(arg1, arg2, 0))
 *;@	randomtimer(1, 3000, 5000);	; setup timer at random
 *;@				;  After arg2+(rand()%arg3) milliseconds,
 *;@				;  event alarm(arg1) will be happen.
 *;@				;  arg1 timer channel number (0...MAXTIMER-1)
 *;@				;  arg2 time (milli-second)
 *;@				;       0 <= arg2 <= 32767 (0:disable timer)
 *;@				;  arg3 range of random time (milli-second)
 *;@				;       0 <= arg3 <= 32767-arg2
 *;@end()			; end event ([quit] is selected)
 *;@	sound("bye.au");	; play PCM sound
 *;@				;  arg1 pcm filename (Sun Audio file)
 *;@alarm(1)			; timer alarm
 *;@				;  arg1 timer channel number (0...MAXTIMER-1)
 *;@press("vast.cel")		; mouse button press
 *;@				;  arg1 cell filename or object mark
 *;@	map("facered.cel");	; map cell
 *;@				;  arg1 cell filename
 *;@release("vast.cel")		; mouse button release
 *;@				;  arg1 cell filename or object mark
 *;@	unmap("facered.cel");	; unmap cell
 *;@				;  arg1 cell filename
 *;@catch(#1)			; catch object
 *;@				;  arg1 cell filename or object mark
 *;@	altmap("panties.cel");	; alternate map/unmap cell
 *;@				;  arg1 cell filename
 *;@	altmap("panties2.cel");
 *;@drop(#1)			; release object
 *;@				;  arg1 cell filename or object mark
 *;@	altmap("panties.cel");
 *;@	altmap("panties2.cel");
 *;@fixcatch(#1)		; catch fixed object
 *;@				;  arg1 cell filename or object mark
 *;@	sound("iyaan.au");
 *;@fixdrop(#1)			; release fixed object (and object return)
 *;@				;  arg1 cell filename or object mark
 *;@	move(#1, 10, -2);	; move object
 *;@				;  arg1 object mark
 *;@				;  arg2 delta x (pixel)
 *;@				;  arg3 delta y (pixel)
 *;@unfix(#1)			; fix value is cleared! pesi pesi done.
 *;@	changeset(2);		; change set
 *;@				;  arg1 destination set number (0...setcnt-1)
 *;@	changecol(2);		; change color group
 *;@				;  arg1 destination color number (0...palcnt-1)
 *;@set(1)			; set changed
 *;@				;  arg1 set number
 *;@col(1)			; color group changed
 *;@				;  arg1 color number
 *;@	quit();			; quit
 *;@in("dress.cel", "closet.cel")	; cell in (Not inplemented)
 *;@				;  all pixels of dst. are overlap src. pixels
 *;@				;  arg1 destination cell filename
 *;@				;  arg2 source cell filename
 *;@out("dress.cel", "closet.cel")	; cell out (Not inplemented)
 *;@				;  no pixel of cells is overlap
 *;@				;  arg1 cell filename
 *;@				;  arg2 cell filename
 *;@leftside("a.cel", "b.cel")	; override left side (Not inplemented)
 *;@				;  arg1 cell filename
 *;@				;  arg2 cell filename
 *;@rightside("a.cel", "b.cel")	; override right side (Not inplemented)
 *;@				;  arg1 cell filename
 *;@				;  arg2 cell filename
 *;@upside("a.cel", "b.cel")	; override up side (Not inplemented)
 *;@				;  arg1 cell filename
 *;@				;  arg2 cell filename
 *;@downside("a.cel", "b.cel")	; override down side (Not inplemented)
 *;@				;  arg1 cell filename
 *;@				;  arg2 cell filename
 *
 * number
 *	10			decimal number
 *	010	(= 8)		octal number heading "0"
 *	0x10	(= 16)		hexadecimal number heading "0x"
 * string
 *	"Sample string"		Any string is quoted by double quotation marks.
 *	"\t<- Tab"		\t Tab
 *	"Newline ->\n"		\n Newline
 *	"\\<-Backslash"		\\ Backslash
 *	"\"<- Doublequote"	\" Double quotation mark
 *				Don't use other \ escaped character!
 * object mark
 *	#10			Object mark is "#" started number.
 *
 */

#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <stdio.h>
#include "config.h"
#include "headers.h"
#include "fkiss.h"
#include "work.h"
#include "timer.h"
#define PUBLIC_KISSEVE_C
#include "extern.h"

#define MAXEVENT	64	/* maximum event */
#define MAXACTION	64	/* maximum action for one event */
#define MAXSOUNDFILE	64	/* maximum sound file */
#define MAXTIMER	64	/* maximum timer channel */

/* argument type */
#define OT_CEL	1		/* Cell */
#define OT_OBJ	2		/* Object */
#define OT_SND	3		/* Sound */
#define OT_NUM	4		/* Number */
#define OT_STR	5		/* String */
#define OT_TCH	6		/* Timer channel number */
#define OT_SET	7		/* Set number */
#define OT_COL	8		/* Color group number */

#define EOBJN 3			/* maximum number of event arguments */
#define AOBJN 3			/* maximum number of action arguments */

typedef struct {
  short type;			/* argument type */
  short no;			/* argument code */
  char *name;			/* filename */
} EVOBJ;			/* argument structure */

typedef struct {
  short n;			/* action type */
  EVOBJ aobj[AOBJN];		/* argument */
} ACTION;

typedef struct {
  int elineno;			/* cnf line number */
  short evtype;			/* event type */
  EVOBJ eobj[EOBJN];		/* event argument */
  int alineno;			/* cnf line number action */
  short actn;			/* number of actions (<= MAXACTION) */
  ACTION act[MAXACTION];	/* actions */
} EVT;

typedef struct {
  long settime;
  struct TMV starttime;
} TIMER;

#define CLEAR_TIMER(p) ((active_timer -= !!(p)->settime), (p)->settime = 0)

#define SET_TIMER(ch,n) \
(active_timer -= !!(timertbl+(ch))->settime,\
 bcopy(&tm0, &(timertbl+(ch))->starttime, sizeof(struct TMV)),\
 active_timer += !!((timertbl+(ch))->settime = (n)))


char id_kisseve[] = "$Id: kisseve.c,v 1.14 1995/12/03 05:07:35 yav Exp $";
static Bool event_ok = False;
static EVT *evtbl = NULL;	/* event table */
static EVT *evp;
static int soundn = 0;		/* number of sound files (<= MAXSOUNDFILE) */
static char **soundlist = NULL;
static TIMER *timertbl = NULL;
static int active_timer = 0;	/* number of active timer-channels */
static struct TMV tm0;		/* event occured time */
static long event_delay;	/* event delay milliseconds */
static int redraw_xtop, redraw_ytop;
static int redraw_xend, redraw_yend;

/* keyword table */
typedef struct {
  char *str;			/* keyword */
  short n;			/* code */
  char argt[4];			/* argument type */
} KEYWORD_TABLE;

#define KTBL(code,name,pt0,pt1,pt2,pt3) \
{name, code, {pt0, pt1, pt2, pt3}}

static KEYWORD_TABLE event_syntax[] = {
  /* code		keyword 	pt0	pt1	pt2	pt3 */
  KTBL(EVE_NEVER,	"never",	0,	0,	0,	0),
  KTBL(EVE_INITIALIZE,	"initialize",	0,	0,	0,	0),
  KTBL(EVE_ALARM,	"alarm",	OT_TCH,	0,	0,	0),
  KTBL(EVE_BEGIN,	"begin",	0,	0,	0,	0),
  KTBL(EVE_END,		"end",		0,	0,	0,	0),
  KTBL(EVE_PRESS,	"press",	OT_CEL,	0,	0,	0),
  KTBL(EVE_RELEASE,	"release",	OT_CEL,	0,	0,	0),
  KTBL(EVE_CATCH,	"catch",	OT_CEL,	0,	0,	0),
  KTBL(EVE_DROP,	"drop",		OT_CEL,	0,	0,	0),
  KTBL(EVE_FIXCATCH,	"fixcatch",	OT_CEL,	0,	0,	0),
  KTBL(EVE_FIXDROP,	"fixdrop",	OT_CEL,	0,	0,	0),
  KTBL(EVE_UNFIX,	"unfix",	OT_CEL,	0,	0,	0),
  KTBL(EVE_SET,		"set",		OT_SET,	0,	0,	0),
  KTBL(EVE_COL,		"col",		OT_COL,	0,	0,	0),
  KTBL(EVE_IN,		"in",		OT_CEL,	OT_CEL,	0,	0),
  KTBL(EVE_OUT,		"out",		OT_CEL,	OT_CEL,	0,	0),
  KTBL(EVE_LEFTSIDE,	"leftside",	OT_CEL,	OT_CEL,	0,	0),
  KTBL(EVE_RIGHTSIDE,	"rightside",	OT_CEL,	OT_CEL,	0,	0),
  KTBL(EVE_UPSIDE,	"upside",	OT_CEL,	OT_CEL,	0,	0),
  KTBL(EVE_DOWNSIDE,	"downside",	OT_CEL,	OT_CEL,	0,	0),
  KTBL(ACT_NOP,		"nop",		0,	0,	0,	0),
  KTBL(ACT_DEBUG,	"debug",	OT_STR,	0,	0,	0),
  KTBL(ACT_SHELL,	"shell",	OT_STR,	0,	0,	0),
  KTBL(ACT_UNMAP,	"unmap",	OT_CEL,	0,	0,	0),
  KTBL(ACT_MAP,		"map",		OT_CEL,	0,	0,	0),
  KTBL(ACT_ALTMAP,	"altmap",	OT_CEL,	0,	0,	0),
  KTBL(ACT_MOVE,	"move",		OT_OBJ,	OT_NUM,	OT_NUM,	0),
  KTBL(ACT_SOUND,	"sound",	OT_SND,	0,	0,	0),
  KTBL(ACT_TIMER,	"timer",	OT_TCH,	OT_NUM,	0,	0),
  KTBL(ACT_RANDOMTIMER,	"randomtimer",	OT_TCH,	OT_NUM,	OT_NUM,	0),
  KTBL(ACT_QUIT,	"quit",		0,	0,	0,	0),
  KTBL(ACT_CHANGESET,	"changeset",	OT_SET,	0,	0,	0),
  KTBL(ACT_CHANGECOL,	"changecol",	OT_COL,	0,	0,	0),
  KTBL(-1, 		NULL,		0,	0,	0,	0)
};

#define get_syntax(code) (event_syntax + ((code) & ~(BIT_EVENT|BIT_ACTION)))

int parse_keyword(str)
     char *str;
{
  KEYWORD_TABLE *p;

  for (p = event_syntax; p->n >= 0; p++) {
    if (strcmp(str, p->str) == 0)
      return p->n;
  }
  return -1;			/* keyword not found */
}

int is_token_set(c)
     int c;
{
  static char token_set[] = "#-+/.0123456789_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

  return index(token_set, c) != NULL;
}

/* get token */
char *get_token(token, str)
     char *token;		/* buffer address stored token */
     char *str;			/* string to parse */
{
  int c;
  Bool quoted, escaped;
  
  escaped = quoted = False;
  while (*str && !is_token_set(*str)) {
    if (*str++ == '"') {
      quoted = True;
      break;
    }
  }
  while ((c = *str) != '\0') {
    str++;
    if (!escaped) {
      if (c == '\\') {
	escaped = True;		/* Escape character */
	continue;
      }
      if (quoted ? c == '"' : !is_token_set(c))
	break;
    } else {
      switch (c) {
      case 'n':			/* Newline */
	c = '\n';
	break;
      case 'r':			/* CR */
	c = '\r';
	break;
      case 't':			/* Tab */
	c = '\t';
	break;
      }
      escaped = False;
    }
    *token++ = c;
  }
  *token = '\0';
  return str;			/* return increased string pointer */
}

/* cnf_event - parse event description line in KISS configuration file
 */
int cnf_event(p, lineno)
     char *p;
     int lineno;		/* cnf line number (from 1) */
{
  int i, n;
  char token[256];

  if (evtbl == NULL)
    evtbl = (EVT *)ks_malloc(sizeof(EVT)*MAXEVENT);
  while (*p) {
    p = get_token(token, p);
    if (!token[0])
      break;
    n = parse_keyword(token);
    if (n < 0) {
      msgset("W ``%s'' unknown keyword.\n", token);
      return -1;		/* keyword error */
    }
    if (n & BIT_EVENT) {
      if (evn >= MAXEVENT) {
	msgset("W event number over %d!\n", MAXEVENT);
	return -1;		/* event over error */
      }
      evp = evtbl + evn++;
      evp->elineno = lineno;
      evp->evtype = n;
      for (i = 0; get_syntax(n)->argt[i]; i++) {
	p = get_token(token, p);
	evp->eobj[i].name = ks_strdup(token);
      }
      evp->actn = 0;
    } else if (n & BIT_ACTION) {
      evp->alineno = lineno;
      if (evp->actn >= MAXACTION) {
	msgset("W action number over %d!\n", MAXACTION);
	return -1;		/* action over error */
      }
      evp->act[evp->actn].n = n;
      for (i = 0; get_syntax(n)->argt[i]; i++) {
	p = get_token(token, p);
	evp->act[evp->actn].aobj[i].name = ks_strdup(token);
      }
      evp->actn++;
    }
  }
  return 0;			/* event parse success */
}

int get_named_sound(name)
     char *name;
{
  int i;
  
  for (i = 0; i < soundn; i++)
    if (strcmp(*(soundlist+i), name) == 0)
      return i;
  return -1;
}

int get_named_cell(name)
     char *name;
{
  int i;
  
  for (i = 0; i < celcnt; i++)
    if (strcmp((cell+i)->filename, name) == 0)
      return i;
  return -1;
}

/* return registrated objno */
int regist_object(type, str)
     int type;			/* object type */
     char *str;
{
  int r;
  char buf[MAXPATH];
  
  r = strtol(str, NULL, 0);
  switch (type) {
  case OT_SND:
    ks_filename(buf, str);
    if (soundn >= MAXSOUNDFILE) {
      msg("W sound files over %d!\n", MAXSOUNDFILE);
      return -1;		/* sound file over error */
    }
    *(soundlist+soundn++) = ks_strdup(buf);
    return soundn-1;
  case OT_TCH:
    if (r < 0 || r >= MAXTIMER) {
      msg("W timer channel must be 0 to %d!\n", MAXTIMER-1);
      msg("W ignore timer channel %d.\n", r);
      r = -1;
    }
    break;
  case OT_SET:
    if (r < 0 || r >= 10) {
      msg("W set number must be 0 to %d!\n", setcnt-1);
      msg("W ignore set number %d.\n", r);
      r = -1;
    }
    break;
  case OT_COL:
    if (r < 0 || r >= 10) {
      msg("W col number must be 0 to %d!\n", palcnt-1);
      msg("W ignore col number %d.\n", r);
      r = -1;
    }
    break;
  case OT_NUM:
  case OT_STR:
    break;
  default:
    r = -1;			/* error */
  }
  return r;
}

/* return object type
 * minus : not found
 */
int parse_argument(p, str, rtype)
     EVOBJ *p;
     char *str;
     int rtype;			/* default type */
{
  switch(*str) {
  case '#':
    p->type = OT_OBJ;
    p->no = strtol(str+1, NULL, 10);
    break;
  default:
    p->type = OT_CEL;
    p->no = get_named_cell(str);
    if (p->no < 0) {
      p->type = OT_SND;
      p->no = get_named_sound(str);
    }
    break;
  }
  if (p->no < 0) {
    p->type = rtype;
    p->no = regist_object(rtype, str);
    if (debug_mode)
      fprintf(stderr, " obj(%d,%d)=[%s]", p->type, p->no, str);
    if (p->no < 0 && rtype != OT_NUM && rtype != OT_STR)
      p->type = -1;
  } else {
    if (debug_mode)
      fprintf(stderr, " obj(%d,%d)", p->type, p->no);
  }
  return p->type;
}

/* return : line number error detected (0 no error) */
int compile_event(n)
     int n;
{
  int j, k;
  int r, errline;
  EVT *ep;
  ACTION *ap;
  
  if (!n) {
    /* first line allocate work area */
    soundlist = (char **)ks_malloc(sizeof(char *)*MAXSOUNDFILE);
    timertbl = (TIMER *)ks_malloc(sizeof(TIMER)*MAXTIMER);
    /* reset all timers */
    bzero((char *)timertbl, sizeof(TIMER)*MAXTIMER);
  }
  ep = evtbl + n;
  if (debug_mode)
    fprintf(stderr, "event %d: %s(", n, get_syntax(ep->evtype)->str);
  for (j = 0; get_syntax(ep->evtype)->argt[j]; j++) {
    if (debug_mode)
      fprintf(stderr, "%s%s", !j?"":",", ep->eobj[j].name);
    r = parse_argument(&ep->eobj[j], ep->eobj[j].name,
		       get_syntax(ep->evtype)->argt[j]);
    if (r < 0 && ep->eobj[j].type != OT_NUM && ep->eobj[j].type != OT_STR) {
      ep->evtype = 0;		/* ignore this event */
      return ep->elineno;
    }
  }
  if (debug_mode)
    fprintf(stderr, ").\n");
  errline = 0;			/* reset error line */
  for (ap = ep->act, j = 0; j < ep->actn; ap++, j++) {
    if (debug_mode)
      fprintf(stderr, " action %d: %s(", j, get_syntax(ap->n)->str);
    for (k = 0; get_syntax(ap->n)->argt[k]; k++) {
      if (debug_mode)
	fprintf(stderr, "%s%s", !k?"":",", ap->aobj[k].name);
      r = parse_argument(&ap->aobj[k], ap->aobj[k].name,
			 get_syntax(ap->n)->argt[k]);
      if (r < 0 && ap->aobj[k].type != OT_NUM && ap->aobj[k].type != OT_STR) {
	ap->n = ACT_NOP;	/* ignore this action */
	errline = ep->alineno;
      }
    }
    if (debug_mode)
      fprintf(stderr, ").\n");
  }
  return errline;
}

void init_redraw_area()
{
  redraw_xtop = imgw;
  redraw_ytop = imgh;
  redraw_xend = redraw_yend = 0;
}

void add_redraw_area(x, y, w, h)
     int x;
     int y;
     int w;
     int h;
{
  if (x < redraw_xtop)
    redraw_xtop = x;
  if (y < redraw_ytop)
    redraw_ytop = y;
  if (x + w > redraw_xend)
    redraw_xend = x + w;
  if (y + h > redraw_yend)
    redraw_yend = y + h;
}

void update_redraw_area()
{
  int w, h;
  
  w = redraw_xend - redraw_xtop;
  h = redraw_yend - redraw_ytop;
  if (w > 0 && h > 0)
    redraw_cells(redraw_xtop, redraw_ytop, w, h);
}

/* set timer
 * starttime = tm0 - event_delay
 */
void set_timer(p, n)
     TIMER *p;
     int n;
{
  CLEAR_TIMER(p);
  if (n) {
    bcopy(&tm0, &p->starttime, sizeof(struct TMV));
    add_time(&p->starttime, -event_delay);
    p->settime = n;
    active_timer++;
  }
}

/* change cell mapping status
 * return  0:status is not changed
 */
int change_cel_mapping(cn, status)
     int cn;
     int status;
{
  CELL *p;
  int n;
  
  p = cell + cn;
  switch (status) {
  case ACT_UNMAP:		/* unmap */
    if (p->unmap)
      return 0;			/* already unmapped */
    p->unmap = 1;
    break;
  case ACT_MAP:			/* map */
    if (!p->unmap)
      return 0;			/* already mapped */
    p->unmap = 0;
    break;
  case ACT_ALTMAP:		/* altmap */
    p->unmap ^= 1;
    break;
  default:			/* ??? unknown mode ??? */
    return 0;
  }
  if (debug_mode) {
    fprintf(stderr, "! %s(%d)", p->unmap ? "unmap" : "map", cn);
    if (p->filename != NULL)
      fprintf(stderr, " [%s]", p->filename);
    fprintf(stderr, " !\n");
  }
  n = p->obj;
  add_redraw_area((kset[cset].obj+n)->x, (kset[cset].obj+n)->y,
		  (object+n)->width, (object+n)->height);
  return 1;			/* cel mapping sattus is changed! */
}

int change_aobj_mapping(p, status)
     EVOBJ *p;
     int status;
{
  int i, r;
  
  r = 0;
  switch(p->type) {
  case OT_CEL:
    r = change_cel_mapping(p->no, status);
    break;
  case OT_OBJ:
    for (i = 0; i < celcnt; i++)
      if ((cell+i)->obj == p->no)
	r |= change_cel_mapping(i, status);
    break;
  default:
    msg("W change_aobj_mapping: type %d cannot to change mapping\n", p->type);
    break;
  }
  return r;
}

/*
 * return changed status infrmation bits
 * ACTBIT_SOUND:on sound played
 * ACTBIT_MAP:on cell mapping status changed
 */
int event_action(p, r)
     EVT *p;
     int r;
{
  int i, n;
  int mapping_action;
  int newset, newcol;
  ACTION *ap;
  AREA ar;
  
  newset = newcol = -1;
  for (ap = p->act, i = 0; i < p->actn; ap++, i++) {
    n = mapping_action = 0;
    switch(ap->n) {
    case ACT_SOUND:
      if (!(r & ACTBIT_SOUND)) {
	if (debug_mode)
	  fprintf(stderr, "! sound(%s) !\n", *(soundlist+ap->aobj[0].no));
	bg_play(*(soundlist+ap->aobj[0].no));
	r |= ACTBIT_SOUND;
      }
      break;
    case ACT_MAP:
    case ACT_UNMAP:
    case ACT_ALTMAP:
      mapping_action = ap->n;
      break;
    case ACT_CHANGESET:
      newset = ap->aobj[0].no;
      break;
    case ACT_CHANGECOL:
      newcol = ap->aobj[0].no;
      break;
    case ACT_RANDOMTIMER:
      if (ap->aobj[1].no && ap->aobj[2].no)
	n = ks_rand() % ap->aobj[2].no;
      /* FALL THROUGH */
    case ACT_TIMER:
      n += ap->aobj[1].no;
      set_timer(timertbl+ap->aobj[0].no, n);
      if (debug_mode) {
	fprintf(stderr, "! timer(%d,%d) ", ap->aobj[0].no, n);
	if (n)
	  fprintf(stderr, "%.19s.%06ld ",
		  ctime(&(timertbl+ap->aobj[0].no)->starttime.tv_sec),
		  (timertbl+ap->aobj[0].no)->starttime.tv_usec);
	fprintf(stderr, " !\n");
      }
      break;
    case ACT_MOVE:
      n = ap->aobj[0].no;
      if (ap->aobj[0].type == OT_CEL)
	n = (cell+n)->obj;
      if (move_object2(n,
		       (kset[cset].obj+n)->x + ap->aobj[1].no,
		       (kset[cset].obj+n)->y + ap->aobj[2].no,
		       &ar)) {
	add_redraw_area(ar.x, ar.y, ar.w, ar.h);
	r |= ACTBIT_MAP;
	if (debug_mode)
	  fprintf(stderr, "! move(%d,%d,%d) !\n",
		  n, (kset[cset].obj+n)->x, (kset[cset].obj+n)->y);
      }
      break;
    case ACT_SHELL:
      if (debug_mode)
	fprintf(stderr, "! shell(%s) !\n", ap->aobj[0].name);
      if (enable_event_shell)
	bg_shell(ap->aobj[0].name);
      break;
    case ACT_DEBUG:
      if (debug_mode)
	fprintf(stderr, "! debug(%s) !\n", ap->aobj[0].name);
      fputs(ap->aobj[0].name, stderr);
      break;
    case ACT_QUIT:
      if (debug_mode)
	fprintf(stderr, "! quit !\n");
      change_menu_func(1);	/* Quit */
      break;
    default:
      break;
    }
    if (mapping_action && change_aobj_mapping(&ap->aobj[0], mapping_action))
      r |= ACTBIT_MAP;
  }
  if (newset != -1 || newcol != -1)
    change_setpal(newset, newcol);
  return r;
}

int handler_sub(type, arg)
     int type;
     int arg;
{
  int i, r, n;
  EVT *ep;

  if (debug_mode)
    fprintf(stderr, "event: %s, arg: %d at %.19s.%06ld\n",
	    get_syntax(type)->str, arg,
	    ctime(&tm0.tv_sec), tm0.tv_usec);
  init_redraw_area();
  r = 0;
  for (ep = evtbl, i = 0; i < evn; ep++, i++) {
    if (ep->evtype != type)
      continue;			/* no match, check next */
    switch (type) {
    case EVE_INITIALIZE:
      event_action(ep, r);
      break;
    case EVE_BEGIN:
    case EVE_END:
      r |= event_action(ep, r);
      break;
    case EVE_ALARM:
      if (arg == ep->eobj[0].no)
	r |= event_action(ep, r);
      break;
    case EVE_PRESS:
    case EVE_RELEASE:
    case EVE_CATCH:
    case EVE_DROP:
    case EVE_FIXCATCH:
    case EVE_FIXDROP:
    case EVE_UNFIX:
      n = arg;
      if (n >= 0 && ep->eobj[0].type == OT_OBJ)
	n = (cell+n)->obj;
      if (n == ep->eobj[0].no)
	r |= event_action(ep, r);
      break;
    case EVE_SET:
    case EVE_COL:
      if (arg == ep->eobj[0].no)
	r |= event_action(ep, r);
      break;
    default:			/* others, Not implemented */
      break;
    }
  }
  if (r & ACTBIT_MAP)		/* cell mapping status changed? */
    update_redraw_area();
  return r;
}

int kissevent_handler(type, arg)
     int type;
     int arg;
{
  if (!event_ok)
    return 0;
  current_time(&tm0);
  event_delay = 0;
  return handler_sub(type, arg);
}

/* initialise random seed */
void init_rand()
{
  int i;
  
  i = randseed;
  if (!i) {
    current_time(&tm0);
    i = tm0.tv_sec;
  }
  ks_srand(i);
}

typedef struct {
  long filesize;
  char *pathname;
} SOUND_SORT_TABLE;

int sound_cache_prio(p0, p1)
     SOUND_SORT_TABLE *p0;
     SOUND_SORT_TABLE *p1;
{
  return p0->filesize - p1->filesize;
}

/* preload sound data to cache buffer
 * from small to big size sound file
 */
void preload_sound_cache()
{
  int i;
  SOUND_SORT_TABLE *p;
  long total;
  
  if (!sound_mode)
    return;
  p = malloc(sizeof(SOUND_SORT_TABLE) * soundn);
  if (p == NULL)
    return;
  for (i = 0; i < soundn; i++) {
    (p+i)->pathname = *(soundlist+i);
    (p+i)->filesize = sound_filesize(*(soundlist+i));
  }
  qsort(p, soundn, sizeof(SOUND_SORT_TABLE), sound_cache_prio);
  total = 0;
  for (i = 0; i < soundn; i++) {
    if ((p+i)->filesize < 0)
      continue;			/* unknown size, ignore */
    if (total + (p+i)->filesize > sound_cache_limit)
      break;			/* total size over limit! */
    if (sound_cache((p+i)->pathname) >= 0) {
      if (debug_mode)
	fprintf(stderr, "preload sound file ``%s''\t(%8ld bytes).\n",
		(p+i)->pathname, (p+i)->filesize);
      total += (p+i)->filesize;
    }
  }
  if (debug_mode)
    fprintf(stderr, "preloaded sound total %8ld bytes (limit %8ld bytes).\n",
	    total, sound_cache_limit);
  free(p);
}

int kissevent_initialize()
{
  init_rand();
  preload_sound_cache();
  event_ok = True;
  kissevent_handler(EVE_INITIALIZE, 0);
  return 0;
}

void kissevent_timer()
{
  int i;
  TIMER *p;
  
  if (!event_ok || !active_timer)
    return;			/* active timer channel is not exist */
  current_time(&tm0);
  for (p = timertbl, i = 0; i < MAXTIMER; p++, i++) {
    if (p->settime) {
      event_delay = diff_time(&tm0, &p->starttime) - p->settime;
      if (event_delay >= 0) {
	if (debug_mode)
	  fprintf(stderr, "event_delay = %ld\n", event_delay);
	/* reset timer */
	CLEAR_TIMER(p);
	handler_sub(EVE_ALARM, i);
      }
    }
  }
}

/* End of file */
