/* $Header: /home/yav/fkiss/RCS/message.c,v 1.1 1995/11/30 20:49:35 yav Exp $
 * fkiss message
 * written by yav (UHD98984@pcvan.or.jp)
 */

#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <stdio.h>
#include "config.h"

#include "headers.h"
#include "fkiss.h"
#include "work.h"
#define PUBLIC_MESSAGE_C
#include "extern.h"

#if HAVE_STDARG_H
# include <stdarg.h>
#else
# if HAVE_VARARGS_H
#  include <varargs.h>
# endif
#endif

char id_message[] = "$Id: message.c,v 1.1 1995/11/30 20:49:35 yav Exp $";
static char *msgbuf;
static char *msgp;

#define CLEAR_MESSAGE() (*(msgp = msgbuf) = '\0')

void msg_init(p)
     char *p;
{
  msgbuf = p;
  CLEAR_MESSAGE();
}

int msg_queued()
{
  return msgp - msgbuf;
}

void prmsg()
{
  Bool f;
  char *p;
  char *prompt;
  
  f = False;
  p = NULL;
  prompt = *oargv;
  switch(*msgbuf) {
  case '\0':
    break;
  case 'V':
    if (verbose_mode & 2) {
      prompt = NULL;
      p = "";
    }
    break;
  case 'W':
    if (verbose_mode)
      p = " warning:";
    break;
  case 'E':
    f = True;
    p = " error:";
    break;
  default:
    p = "";
    break;
  }
  if (p != NULL) {
    if (prompt != NULL)
      fprintf(stderr, "%s:", prompt);
    fprintf(stderr, "%s%s", p, msgbuf+1);
  }
  CLEAR_MESSAGE();
  if (f)
    kiss_exit(1);
}

void msgset(const char *format, ...)
{
  va_list ap;
  
  va_start(ap, format);
  vsprintf(msgp, format, ap);
  msgp += strlen(msgp);
  va_end(ap);
}

void msg(const char *format, ...)
{
  va_list ap;
  
  va_start(ap, format);
  vsprintf(msgp, format, ap);
  prmsg();
  va_end(ap);
}

/* End of file */
